<!doctype html>
<html class="no-js" lang="PL-pl">

<head>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1"/>

    <title></title>
    <link rel="stylesheet" id="mainCss" href="pico.min.css">
    <link rel="stylesheet alternate" id="altCss" href="40.css">
    <!--    <link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/@picocss/pico@1/css/pico.min.css">-->

    <style>
        nav {
            display: block;
        }

        h1, h2, h3, h4, h5, h6 {
            margin-bottom: 0.25em;
            margin-top: 0.25em;
        }

        #historiaCzatu {
            display: flex;
            flex-wrap: nowrap;
            flex-direction: column;
            align-content: flex-start;
        }

        span {
            margin: 1em;
        }

        ol {
            list-style-type: none;
        }

        .czatImg {
            width: 3em;
            height: 3em;
        }

        .wiadomoscCzatu {
            display: inline-block;
        }


        @media screen {
            :root {
                --default-height: 7em;
                --dialog-div-width: 70%;
                --dialog-gap: 0.5em;
            }

            dialog button {
                padding: 0;
                margin: 0.5em 0.5em 0.5em;
            }

            dialog button img {
                width: 75px !important;
                height: 75px !important;
            }

            .closeDialogButton {
                margin-top: -2em;
                height: 4em;
            }
        }

        /*slabe wartosci*/
        @media (max-width: 70em), (max-width: 700px) {
            body {
                /*background: aquamarine !important;*/
            }

            :root {
                --default-height: 4em;
                --dialog-div-width: 100%;
                --dialog-gap: 0.25em;

            }

            dialog button {
                padding: 0;
                margin: 0 0.25em 0.25em;
            }

            dialog button img {
                width: 35px !important;
                height: 35px !important;
            }

            .closeDialogButton {
                height: 2em;
                padding: 0;
            }
        }

        .closeDialogButton {
            width: 66%;
            margin: -1.5em auto auto auto;
        }


        dialog ol {
            display: flex;
            gap: var(--dialog-gap);
            align-items: center;
            justify-content: center;
            flex-wrap: wrap;
        }

        dialog li {
            flex: 0 1 var(--default-height);
        }

        dialog button {
            height: var(--default-height);
        }

        #dialogSpojnik li {
            flex: 1 0 3em;
        }

        #dialogSpojnik button {
            height: 3em;
        }

        dialog > div {
            margin-left: auto;
            margin-right: auto;
            width: var(--dialog-div-width);

            border: 1px solid black;
            padding: 1em;
        }

        dialog > div h3 {
            margin: 0;
        }

        dialog[open] {
            display: block !important;
            padding-top: 10%;
            padding-left: 10%;
            padding-right: 10%;


        }


        #listaKontrolki {
            gap: 0.25em;
            display: flex;
            flex-direction: row;
            justify-content: start;
        }

        #listaKategorie {
            gap: 0.25em;
            display: flex;
            flex-direction: row;
            justify-content: start;
        }


    </style>


</head>

<body>


<div class="container">
    <main aria-label="Okno czatu">
        <h1 aria-details="opisCzatu">Czat</h1>
        <p>
            Opis aplikacji:
            Aplikacja czatu powstała w ramach projektu "Doświadcz tego sam".
            Czat wspiera proces komunikacji alternatywnej i wspomagającej - osoby, który nie posługują językiem
            polskim pisanym mogą budować zdania za pomocą piktogramów.
            Aplikacja, dzięki wykorzastaniu standardów WAI-ARIA (Web Accessibility Initiative – Accessible Rich Internet
            Applications)
            jest dostępna dla osób niewidomych i słabowidzących.
            Aktualnie czat działa wyłącznie lokalnie - pozwala na komunikację pomiędzy osobami znajdującymi się przy
            jednym urządzeniu.
            Wykorzystane piktogramy pochodzą ze strony <a href="https://mulberrysymbols.org">mulberrysymbols.org</a>
        </p>
        <h2>Okno czatu:</h2>
        <div style="border: 1px black solid; min-height: 5em"
             id="historiaCzatu">
            <ol aria-label="Okno czatu" id="historiaCzatuList">
            </ol>
        </div>
        <h2 id="aktualnieBudowanaWiadomosc">Aktualnie budowana wiadomość:</h2>
        <p aria-describedby="aktualnieBudowanaWiadomosc" style="border: 1px black solid; min-height: 1em"
           id="zdanieDoWypowiedzenia">
        </p>
    </main>


    <aside aria-label="sekcja kontrolek czatu">
        <h1 aria-details="opisKontrolekIopisKategorii">
            Kontrolki Czatu
        </h1>
        <ol aria-label="lista kontrolek czatu" id="listaKontrolki">
            <li>
                <button id="buttonCzytaj" onclick="czytajZdanie()">Wyślij</button>
            </li>
            <li>
                <button id="buttonCofnij" onclick="cofnijZdanie()">Cofnij słowo</button>
            </li>
            <li>
                <button id="buttonUsun" onclick="usunZdanie()">Wyczyść wiadomość</button>
            </li>
        </ol>

        <dialog id="dialogOsoby">
            <div>
                <h3>Kategoria Osoby:</h3>
                <ol>
                    <li>
                        <button id="11" data-value="mama" onclick="test(this.id)">
                            <img role="presentation" src="EN-symbols/mum_parent.svg" alt="mama">
                            <br aria-hidden="true">
                            mama
                        </button>
                    </li>
                    <li>
                        <button id="12" data-value="tata" onclick="test(this.id)">
                            <img role="presentation" src="EN-symbols/dad_parent.svg" alt="tata">
                            <br aria-hidden="true">
                            tata
                        </button>
                    </li>
                    <li>
                        <button id="13" data-value="siostra" onclick="test(this.id)">
                            <img role="presentation" src="EN-symbols/sister.svg" alt="siostra">
                            <br aria-hidden="true">
                            siostra
                        </button>
                    </li>
                    <li>
                        <button id="14" data-value="brat" onclick="test(this.id)">
                            <img role="presentation" src="EN-symbols/brother.svg" alt="brat">
                            <br aria-hidden="true">
                            brat
                        </button>
                    </li>
                    <li>
                        <button id="15" data-value="ja" onclick="test(this.id)">
                            <img role="presentation" src="EN-symbols/me.svg" alt="ja">
                            <br aria-hidden="true">
                            ja
                        </button>
                    </li>
                </ol>
                <button class="closeDialogButton" onclick="closeDialog()">Zamknij</button>
            </div>
        </dialog>

        <dialog id="dialogCzynnosci">
            <div>
                <h3>Kategoria Czynności:</h3>
                <ol>
                    <li>
                        <button id="21" data-value="idzie" onclick="test(this.id)">
                            <img role="presentation" src="EN-symbols/walk_,_to.svg" alt="idzie">
                            <br aria-hidden="true">
                            idzie
                        </button>
                    </li>
                    <li>
                        <button id="22" data-value="mówi" onclick="test(this.id)">
                            <img role="presentation" src="EN-symbols/talk_1_,_to.svg" alt="mówi">
                            <br aria-hidden="true">
                            mówi
                        </button>
                    </li>
                    <li>
                        <button id="23" data-value="nieść" onclick="test(this.id)">
                            <img role="presentation" src="EN-symbols/carry_,_to.svg" alt="nieść">
                            <br aria-hidden="true">
                            nieść
                        </button>
                    </li>
                    <li>
                        <button id="24" data-value="zmywać" onclick="test(this.id)">
                            <img role="presentation" src="EN-symbols/wash_up_,_to.svg" alt="zmywać">
                            <br aria-hidden="true">
                            zmywać
                        </button>
                    </li>
                    <li>
                        <button id="25" data-value="jeść" onclick="test(this.id)">
                            <img role="presentation" src="EN-symbols/delicious_food.svg" alt="jeść">
                            <br aria-hidden="true">
                            jeść
                        </button>
                    </li>
                    <li>
                        <button id="26" data-value="modlić się" onclick="test(this.id)">
                            <img role="presentation" src="EN-symbols/pray_,_to.svg" alt="modlić się">
                            <br aria-hidden="true">
                            modlić
                        </button>
                    </li>
                </ol>
                <button class="closeDialogButton" onclick="closeDialog()">Zamknij</button>
            </div>
        </dialog>

        <dialog id="dialogMiejsca">
            <div>
                <h3>Kategoria Miejsca:</h3>
                <ol>
                    <li>
                        <button id="31" data-value="kawiarnia" onclick="test(this.id)">
                            <img role="presentation" src="EN-symbols/cafe.svg" alt="kawiarnia">
                            <br aria-hidden="true">
                            kawiarnia
                        </button>
                    </li>
                    <li>
                        <button id="32" data-value="dom" onclick="test(this.id)">
                            <img role="presentation" src="EN-symbols/house.svg" alt="dom">
                            <br aria-hidden="true">
                            dom
                        </button>
                    </li>
                    <li>
                        <button id="33" data-value="garaż" onclick="test(this.id)">
                            <img role="presentation" src="EN-symbols/garage.svg" alt="garaż">
                            <br aria-hidden="true">
                            garaż
                        </button>
                    </li>
                    <li>
                        <button id="34" data-value="kościół" onclick="test(this.id)">
                            <img role="presentation" src="EN-symbols/church.svg" alt="kościół">
                            <br aria-hidden="true">
                            kościół
                        </button>
                    </li>
                </ol>
                <button class="closeDialogButton" onclick="closeDialog()">Zamknij</button>
            </div>
        </dialog>

        <dialog id="dialogPrzedmioty">
            <div>
                <h3>Kategoria Przedmioty:</h3>
                <ol>
                    <li>
                        <button id="41" data-value="kubek" onclick="test(this.id)">
                            <img role="presentation" src="EN-symbols/waste_paper_bin.svg" alt="kubek">
                            <br aria-hidden="true">
                            kubek
                        </button>
                    </li>
                    <li>
                        <button id="42" data-value="talerz" onclick="test(this.id)">
                            <img role="presentation" src="EN-symbols/plate.svg" alt="talerz">
                            <br aria-hidden="true">
                            talerz
                        </button>
                    </li>
                    <li>
                        <button id="43" data-value="długopis" onclick="test(this.id)">
                            <img role="presentation" src="EN-symbols/pen.svg" alt="długopis">
                            <br aria-hidden="true">
                            długopis
                        </button>
                    </li>
                    <li>
                        <button id="44" data-value="zeszyt" onclick="test(this.id)">
                            <img role="presentation" src="EN-symbols/notebook.svg" alt="zeszyt">
                            <br aria-hidden="true">
                            zeszyt
                        </button>
                    </li>
                    <li>
                        <button id="45" data-value="piłka" onclick="test(this.id)">
                            <img role="presentation" src="EN-symbols/football.svg" alt="piłka">
                            <br aria-hidden="true">
                            piłka
                        </button>
                    </li>
                </ol>
                <button class="closeDialogButton" onclick="closeDialog()">Zamknij</button>
            </div>
        </dialog>

        <dialog id="dialogTransport">
            <div>
                <h3>Kategoria Przedmioty:</h3>
                <ol>
                    <li>
                        <button id="51" data-value="samochód" onclick="test(this.id)">
                            <img role="presentation" src="EN-symbols/car.svg" alt="samochód">
                            <br aria-hidden="true">
                            samochód
                        </button>
                    </li>
                    <li>
                        <button id="52" data-value="rower" onclick="test(this.id)">
                            <img role="presentation" src="EN-symbols/bicycle.svg" alt="rower">
                            <br aria-hidden="true">
                            rower
                        </button>
                    </li>
                    <li>
                        <button id="53" data-value="autobus" onclick="test(this.id)">
                            <img role="presentation" src="EN-symbols/bus.svg" alt="autobus">
                            <br aria-hidden="true">
                            autobus
                        </button>
                    </li>
                    <li>
                        <button id="54" data-value="pociąg" onclick="test(this.id)">
                            <img role="presentation" src="EN-symbols/train.svg" alt="pociąg">
                            <br aria-hidden="true">
                            pociąg
                        </button>
                    </li>
                    <li>
                        <button id="55" data-value="wózek inwalidzki" onclick="test(this.id)">
                            <img role="presentation" src="EN-symbols/wheelchair.svg" alt="wózek inwalidzki">
                            <br aria-hidden="true">
                            wózek inwalidzki
                        </button>
                    </li>
                </ol>
                <button class="closeDialogButton" onclick="closeDialog()">Zamknij</button>
            </div>
        </dialog>

        <dialog id="dialogJedzenie">
            <div>
                <h3>Kategoria Przedmioty:</h3>
                <ol>
                    <li>
                        <button id="61" data-value="kapusta" onclick="test(this.id)">
                            <img role="presentation" src="EN-symbols/cabbage.svg" alt="kapusta">
                            <br aria-hidden="true">
                            kapusta
                        </button>
                    </li>
                    <li>
                        <button id="62" data-value="ziemniak" onclick="test(this.id)">
                            <img role="presentation" src="EN-symbols/potato.svg" alt="ziemniak">
                            <br aria-hidden="true">
                            ziemniak
                        </button>
                    </li>
                    <li>
                        <button id="63" data-value="cukierek" onclick="test(this.id)">
                            <img role="presentation" src="EN-symbols/sweet.svg" alt="cukierek">
                            <br aria-hidden="true">
                            cukierek
                        </button>
                    </li>
                    <li>
                        <button id="64" data-value="makaron" onclick="test(this.id)">
                            <img role="presentation" src="EN-symbols/pasta.svg" alt="makaron">
                            <br aria-hidden="true">
                            makaron
                        </button>
                    </li>
                    <li>
                        <button id="65" data-value="mięso" onclick="test(this.id)">
                            <img role="presentation" src="EN-symbols/meat.svg" alt="mięso">
                            <br aria-hidden="true">
                            mięso
                        </button>
                    </li>
                </ol>
                <button class="closeDialogButton" onclick="closeDialog()">Zamknij</button>
            </div>
        </dialog>


        <dialog id="dialogSpojnik">
            <div>
                <h3>Kategoria Spójniki:</h3>
                <ol>
                    <li>
                        <button id="91" data-value="i" onclick="test(this.id)">i</button>
                    </li>
                    <li>
                        <button id="92" data-value="na" onclick="test(this.id)">na</button>
                    </li>
                    <li>
                        <button id="93" data-value="w" onclick="test(this.id)">w</button>
                    </li>
                    <li>
                        <button id="94" data-value="do" onclick="test(this.id)">do</button>
                    </li>
                    <li>
                        <button id="95" data-value="z" onclick="test(this.id)">z</button>
                    </li>
                </ol>

                <button class="closeDialogButton" onclick="closeDialog()">Zamknij</button>

            </div>
        </dialog>

        <h1 aria-details="opisKategorii">
            Kategorie:
        </h1>
        <ol aria-label="Lista kategorii" id="listaKategorie">
            <li>
                <button onclick="showDialog('dialogOsoby')"> Osoby</button>
            </li>
            <li>
                <button onclick="showDialog('dialogCzynnosci')"> Czynności</button>
            </li>
            <li>
                <button onclick="showDialog('dialogMiejsca')"> Miejsca</button>
            </li>
            <li>
                <button onclick="showDialog('dialogPrzedmioty')"> Przedmioty</button>
            </li>
            <li>
                <button onclick="showDialog('dialogTransport')"> Transport</button>
            </li>
            <li>
                <button onclick="showDialog('dialogJedzenie')"> Jedzenie</button>
            </li>

            <li>
                <button onclick="showDialog('dialogSpojnik')"> Spójniki</button>
            </li>
        </ol>
    </aside>

    <aside aria-label="Pomoc">
        <h1>Dodatkowa pomoc: </h1>
        <h3>Czat</h3>
        <p role="definition" id="opisCzatu">
            Poniżej nagłówka "Czat" znajduje się okno czatu, w którym pojawiać się bedą nowe wiadomości.
            Następnie znajduje się pole, w którym pojawiać się bedą kolejne słowa budowanej wiadomości.
            Okno czatu reprezentowane jest poprzez uporządkowaną listę wiadomości.
        </p>
        <h3>Kontrolki czatu</h3>
        <div id="opisKontrolekIopisKategorii">
            <div role="definition" id="opisKontrolek">
                <p>
                    Czat kontrolowany jest następującymi przyciskami:<br>
                    Wyślij &mdash; wysyła wiadomość, a następnie odczytuje ją za pomocą syntezatora mowy. <br>
                    Cofnij słowo &mdash; cofa wpisane ostatnio słowo - podobnie jak przycisk backspace.<br>
                    Wyczyść wiadomość &mdash; usuwa budowaną aktualnie wiadomość. <br>
                </p>
                <p>
                    Wiadomość wprowadza się wybierając pojedyncze słowa z kategorii znajdujących się na liście pod
                    kontrolkami czatu
                </p>
            </div>
            <div role="definition" id="opisKategorii">
                <p>
                    Po wybraniu kategorii otwiera się okno dialogowe z listą wyrazów z danej kategorii.
                    Okno dialogowe można zamknąć przyciskiem ESCAPE, lub wybierając przycisk zamknij znajdujący się
                    bezpośrednio za listą wyrazów
                </p>
            </div>
        </div>
        <h3>Dodatkowe opcje</h3>
        <div style="width: 25%">
            <button style="background: var(--primary)!important" onclick="toggleCss()">
                <span style="margin: 0; padding: 0; background: var(--primary)!important" id="toggleCss">włącz</span>
                tryb dużego kontrastu
            </button>
        </div>
    </aside>

</div>
</body>
<script>
    let dialog;
    const zdanieDoWypowiedzenia = document.getElementById('zdanieDoWypowiedzenia');
    const historiaCzatu = document.getElementById('historiaCzatuList');
    const pustaWiadomoscClass = 'pustaWiadomosc';
    const pustaWiadomoscSelector = `.${pustaWiadomoscClass}`;
    const aktualnaWiadomoscJestPustaText = "Aktualnie budowana wiadomość jest pusta";
    const pierwszaWiadomosc = 'dołączył do czatu';

    function showDialog(dialogId) {
        if (dialog) {
            dialog.close();
        }
        dialog = document.getElementById(dialogId);
        dialog.show();
    }

    function closeDialog() {
        dialog.close();
    }

    function test(id) {

        document.querySelectorAll(pustaWiadomoscSelector).forEach(e => e.parentNode.removeChild(e));
        const node = document.getElementById(id)
        const value = node.dataset.value;

        let htmlSpanElement = document.createElement('span');
        const originalImg = document.querySelector(`button[data-value="${value}"]`).querySelector('img');
        if (originalImg) {
            const img = originalImg.cloneNode(true);
            img.classList.add('czatImg');
            htmlSpanElement.append(img);
        }

        htmlSpanElement.innerHTML += value;

        zdanieDoWypowiedzenia.appendChild(htmlSpanElement);

        dialog.close();
    }

    function czytajZdanie() {
        if (czyAktualnieWiadomoscJestPusta()) {
            focusAktualneZdanie();
            return;
        }
        document.querySelectorAll(pustaWiadomoscSelector).forEach(e => e.parentNode.removeChild(e));
        let text = Array.from(zdanieDoWypowiedzenia.children).map(e =>
            e.textContent
        ).join(' ');


        text = text + '.';


        text = text.charAt(0).toUpperCase() + text.slice(1);

        let htmlSpanElement = document.createElement('li');
        const currentDate = new Date();

        htmlSpanElement.innerHTML = `${currentDate.toLocaleTimeString('pl-PL')} User1: `;
        const zdanieClone = zdanieDoWypowiedzenia.cloneNode(true);
        zdanieClone.style = '';
        zdanieClone.classList.add('wiadomoscCzatu')
        htmlSpanElement.append(zdanieClone);

        historiaCzatu.append(htmlSpanElement);

        console.log(text);
        const msg = new SpeechSynthesisUtterance();
        msg.text = text;
        msg.lang = "pl-PL";
        window.speechSynthesis.speak(msg);

        usunZdanie();
    }

    function cofnijZdanie() {
        if (czyAktualnieWiadomoscJestPusta()) {
            focusAktualneZdanie();
            return;
        }
        zdanieDoWypowiedzenia.removeChild(zdanieDoWypowiedzenia.lastChild);
        if (zdanieDoWypowiedzenia.childNodes.length === 0) {
            zdanieDoWypowiedzenia.append(returnPustaWiadomoscSpan())
        }
    }

    function usunZdanie() {
        if (czyAktualnieWiadomoscJestPusta()) {
            focusAktualneZdanie();
            return;
        }
        zdanieDoWypowiedzenia.replaceChildren();
        zdanieDoWypowiedzenia.append(returnPustaWiadomoscSpan())
    }

    function returnPustaWiadomoscSpan() {
        let pustaWiadomosc = document.createElement('span');
        pustaWiadomosc.classList.add(pustaWiadomoscClass)
        pustaWiadomosc.innerText = aktualnaWiadomoscJestPustaText;
        return pustaWiadomosc;
    }

    function czyAktualnieWiadomoscJestPusta() {
        return document.querySelectorAll('.pustaWiadomosc').length > 0;
    }

    window.onkeydown = function (event) {
        if (event.key === 'Escape') {
            dialog.close();
        }
    }

    function focusAktualneZdanie() {
        zdanieDoWypowiedzenia.focus();
    }

    function toggleCss() {
        const mainCss = document.getElementById("mainCss");
        const altCss = document.getElementById("altCss");
        const toggle = document.getElementById("toggleCss");
        mainCss.rel = mainCss.rel === 'stylesheet' ? 'stylesheet alternate' : 'stylesheet';
        altCss.rel = altCss.rel === 'stylesheet' ? 'stylesheet alternate' : 'stylesheet';
        console.log(toggle.innerText)
        toggle.innerText = toggle.innerText === 'włącz' ? 'wyłącz' : 'włącz';

    }

    document.addEventListener("DOMContentLoaded", function (event) {
        usunZdanie();
        let htmlSpanElement = document.createElement('li');
        const currentDate = new Date();

        htmlSpanElement.innerHTML = `<time role="timer" datetime="00:00">${currentDate.toLocaleTimeString('pl-PL')}</time> User1: ${pierwszaWiadomosc}`;
        historiaCzatu.append(htmlSpanElement);

    });


</script>

</html>
